function val = f(problem,x1,x2)
% This file is part of the OPTPDE problem collection
%                 http://www.optpde.net
% It is provided as is, without any warranty, under the 
%
% Creative Commons Attribution-NonCommercial ShareAlike 4.0 International
%
%         http://creativecommons.org/licenses/by-nc-sa/4.0/
%
% Please give proper credits when using this file by referencing the 
% collection. For this purpose detailed bibliography data is 
% available at the collections website 
%                  
%                 http://www.optpde.net
%
% This file contains data for the benchmark problem 
%                      scdist2
% from  2022-04-01 



% remember the size of the input and resize it
[m,n] = size(x1);
x1 = x1(:)';
x2 = x2(:)';

% evaluate the function
r = problem.b / 2 - 9 * problem.m / (1 - problem.s);
val = zeros(size(x1));
ix1 = find(x1 < problem.s);
ix2 = find(x1 >= problem.s);
val(ix1) = 6 * problem.s^(-2) - 6 * problem.m * x1(ix1) + x1(ix1) .* (x1(ix1) - 2) + problem.b * (1 - problem.s) * x1(ix1);
val(ix2) = (1 - r) * x1(ix2).^2 + (problem.b - (18 * problem.m * problem.s) / (1 - problem.s) - 2 - 6 * problem.m) * x1(ix2) + 6 * problem.s^(-2) - r * problem.s^2;

% reshape the output
val = reshape(val,m,n);

